Bullet Collision Detection & Physics Library: btBox2dShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Private Attributes | List of all members
btBox2dShape Class Reference

The btBox2dShape is a box primitive around the origin, its sides axis aligned with length specified by half extents, in local shape coordinates. When used as part of a btCollisionObject or btRigidBody it will be an oriented box in world space. More...

`#include <btBox2dShape.h>`

Inheritance diagram for btBox2dShape:
[legend]
Collaboration diagram for btBox2dShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
btVector3 | getHalfExtentsWithMargin () const
const btVector3 & | getHalfExtentsWithoutMargin () const
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
| btBox2dShape (const btVector3 &boxHalfExtents)
| a btBox2dShape is a flat 2D box in the X-Y plane (Z extents are zero)
virtual void | setMargin (btScalar collisionMargin)
virtual void | setLocalScaling (const btVector3 &scaling)
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
int | getVertexCount () const
virtual int | getNumVertices () const
const btVector3 * | getVertices () const
const btVector3 * | getNormals () const
virtual void | getPlane (btVector3 &planeNormal, btVector3 &planeSupport, int i) const
const btVector3 & | getCentroid () const
virtual int | getNumPlanes () const
virtual int | getNumEdges () const
virtual void | getVertex (int i, btVector3 &vtx) const
virtual void | getPlaneEquation (btVector4 &plane, int i) const
virtual void | getEdge (int i, btVector3 &pa, btVector3 &pb) const
virtual bool | isInside (const btVector3 &pt, btScalar tolerance) const
virtual const char * | getName () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
Public Member Functions inherited from btPolyhedralConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btPolyhedralConvexShape ()
virtual | ~btPolyhedralConvexShape ()
virtual bool | initializePolyhedralFeatures (int shiftVerticesByMargin=0)
| optional method mainly used to generate multiple contact points by clipping polyhedral features (faces/edges) experimental/work-in-progress
virtual void | setPolyhedralFeatures (btConvexPolyhedron &polyhedron)
const btConvexPolyhedron * | getConvexPolyhedron () const
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs'
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
btVector3 | m_centroid
btVector3 | m_vertices [4]
btVector3 | m_normals [4]

## Additional Inherited Members
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()
Protected Attributes inherited from btPolyhedralConvexShape
btConvexPolyhedron * | m_polyhedron
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btBox2dShape is a box primitive around the origin, its sides axis aligned with length specified by half extents, in local shape coordinates. When used as part of a btCollisionObject or btRigidBody it will be an oriented box in world space.

Definition at line 26 of file btBox2dShape.h.

## Constructor & Destructor Documentation

## ◆ btBox2dShape()

btBox2dShape::btBox2dShape | ( | const btVector3 & | boxHalfExtents | ) |
| inline

a btBox2dShape is a flat 2D box in the X-Y plane (Z extents are zero)

Definition at line 85 of file btBox2dShape.h.

## Member Function Documentation

## ◆ batchedUnitVectorGetSupportingVertexWithoutMargin()

virtual void btBox2dShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors ) const
| inlinevirtual

Reimplemented from btPolyhedralConvexShape.

Definition at line 71 of file btBox2dShape.h.

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btBox2dShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ calculateLocalInertia()

void btBox2dShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia ) const
| virtual

Reimplemented from btPolyhedralConvexShape.

Definition at line 25 of file btBox2dShape.cpp.

## ◆ getAabb()

void btBox2dShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax ) const
| virtual

getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version

Implements btConvexShape.

Definition at line 20 of file btBox2dShape.cpp.

## ◆ getCentroid()

const btVector3 & btBox2dShape::getCentroid | ( |  | ) | const
| inline

Definition at line 164 of file btBox2dShape.h.

## ◆ getEdge()

virtual void btBox2dShape::getEdge | ( | int | i,
|  | btVector3 & | pa,
|  | btVector3 & | pb ) const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 218 of file btBox2dShape.h.

## ◆ getHalfExtentsWithMargin()

btVector3 btBox2dShape::getHalfExtentsWithMargin | ( |  | ) | const
| inline

Definition at line 38 of file btBox2dShape.h.

## ◆ getHalfExtentsWithoutMargin()

const btVector3 & btBox2dShape::getHalfExtentsWithoutMargin | ( |  | ) | const
| inline

Definition at line 46 of file btBox2dShape.h.

## ◆ getName()

virtual const char * btBox2dShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Definition at line 301 of file btBox2dShape.h.

## ◆ getNormals()

const btVector3 * btBox2dShape::getNormals | ( |  | ) | const
| inline

Definition at line 150 of file btBox2dShape.h.

## ◆ getNumEdges()

virtual int btBox2dShape::getNumEdges | ( |  | ) | const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 174 of file btBox2dShape.h.

## ◆ getNumPlanes()

virtual int btBox2dShape::getNumPlanes | ( |  | ) | const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 169 of file btBox2dShape.h.

## ◆ getNumPreferredPenetrationDirections()

virtual int btBox2dShape::getNumPreferredPenetrationDirections | ( |  | ) | const
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 306 of file btBox2dShape.h.

## ◆ getNumVertices()

virtual int btBox2dShape::getNumVertices | ( |  | ) | const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 140 of file btBox2dShape.h.

## ◆ getPlane()

virtual void btBox2dShape::getPlane | ( | btVector3 & | planeNormal,
|  | btVector3 & | planeSupport,
|  | int | i ) const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 155 of file btBox2dShape.h.

## ◆ getPlaneEquation()

virtual void btBox2dShape::getPlaneEquation | ( | btVector4 & | plane,
|  | int | i ) const
| inlinevirtual

Definition at line 189 of file btBox2dShape.h.

## ◆ getPreferredPenetrationDirection()

virtual void btBox2dShape::getPreferredPenetrationDirection | ( | int | index,
|  | btVector3 & | penetrationVector ) const
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 311 of file btBox2dShape.h.

## ◆ getVertex()

virtual void btBox2dShape::getVertex | ( | int | i,
|  | btVector3 & | vtx ) const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 179 of file btBox2dShape.h.

## ◆ getVertexCount()

int btBox2dShape::getVertexCount | ( |  | ) | const
| inline

Definition at line 135 of file btBox2dShape.h.

## ◆ getVertices()

const btVector3 * btBox2dShape::getVertices | ( |  | ) | const
| inline

Definition at line 145 of file btBox2dShape.h.

## ◆ isInside()

virtual bool btBox2dShape::isInside | ( | const btVector3 & | pt,
|  | btScalar | tolerance ) const
| inlinevirtual

Implements btPolyhedralConvexShape.

Definition at line 284 of file btBox2dShape.h.

## ◆ localGetSupportingVertex()

virtual btVector3 btBox2dShape::localGetSupportingVertex | ( | const btVector3 & | vec | ) | const
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 51 of file btBox2dShape.h.

## ◆ localGetSupportingVertexWithoutMargin()

btVector3 btBox2dShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| inlinevirtual

Reimplemented from btPolyhedralConvexShape.

Definition at line 62 of file btBox2dShape.h.

## ◆ setLocalScaling()

virtual void btBox2dShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 120 of file btBox2dShape.h.

## ◆ setMargin()

virtual void btBox2dShape::setMargin | ( | btScalar | collisionMargin | ) |
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 110 of file btBox2dShape.h.

## Member Data Documentation

## ◆ m_centroid

btVector3 btBox2dShape::m_centroid
| private

Definition at line 31 of file btBox2dShape.h.

## ◆ m_normals

btVector3 btBox2dShape::m_normals[4]
| private

Definition at line 33 of file btBox2dShape.h.

## ◆ m_vertices

btVector3 btBox2dShape::m_vertices[4]
| private

Definition at line 32 of file btBox2dShape.h.

The documentation for this class was generated from the following files:

- btBox2dShape.h
- btBox2dShape.cpp